#include <iostream>


using namespace std;

struct sFieldData
{
    int status;
    /*0 = Loch   ' '
      1 = Gras   '.'
      2 = Stein  'o'
      3 = Berg   'O'
      4 = Wald   'X'
      5 = Wasser '~'*/
    bool enemy;
    char cName[30];
};

const int PlayFieldX = 5;
const int PlayFieldY = 5;
sFieldData sSpielfeld[PlayFieldX][PlayFieldY];

void showPlayfield()
{
    for (int y = 0; y < PlayFieldY; y++)
    {
     for (int x = 0; x < PlayFieldX; x++)
     {


        if (sSpielfeld[x][y].enemy == true)
        {
          cout << "*";
        }
        else
        {
        switch (sSpielfeld[x][y].status)
        {
            //0 = Loch   ' '
            case 0:
            {
                cout << " ";
            }break;
            //1 = Gras   '.'
            case 1:
            {
                cout << ".";
            }break;
            //2 = Stein  'o'
            case 2:
            {
                cout << "o";
            }break;
            //3 = Berg   'O'
            case 3:
            {
                cout << "O";
            }break;
            //4 = Wald   'X'
            case 4:
            {
                cout << "X";
            }break;
            //5 = Wasser '~'*/
            case 5:
            {
                cout << "~";
            }break;
        } //case - Ende
        } //Else - Ende

     }
     cout << endl;
    }
    cout << endl;
}

void setField()
{
    int x, y;
    char Enemy[5];

    do
    {
    cout << "x-Position (1-" << PlayFieldX << "): ";
    cin >> x;
    cout << "y-Position (1-" << PlayFieldY << "): ";
    cin >> y;
    } while(x < 1 || x > PlayFieldX || y < 1 || y > PlayFieldY );

    /*0 = Loch   ' '
      1 = Gras   '.'
      2 = Stein  'o'
      3 = Berg   'O'
      4 = Wald   'X'
      5 = Wasser '~'*/
    do
    {
    cout << "\nWaehlen sie eine Bodenbeschaffenheit: " << endl;
    cout << "0 - Loch" << endl;
    cout << "1 - Gras" << endl;
    cout << "2 - Stein" << endl;
    cout << "3 - Berg" << endl;
    cout << "4 - Wald" << endl;
    cout << "5 - Wasser" << endl;
    cin >> sSpielfeld[x-1][y-1].status;
    } while (sSpielfeld[x-1][y-1].status < 0 || sSpielfeld[x-1][y-1].status > 5);
    cout << endl;


    cout << "Soll dort ein Gegner sein?: ";
    cin.ignore();
    cin.get(Enemy,4);
    cout << endl;


    if (Enemy[0] == 'J' || Enemy[0] == 'j' )
    {
        sSpielfeld[x-1][y-1].enemy = true;
        cout << "Wie soll der Gegner heissen?" << endl;
        cout << "Name: ";
        cin.ignore();
        cin.get(sSpielfeld[x-1][y-1].cName,29);
        cout << endl;

    }
    else
    {
        sSpielfeld[x-1][y-1].enemy = false;
    }
}

void showField()
{
    int x, y;
    do
    {
    cout << "x-Position (1-" << PlayFieldX << "): ";
    cin >> x;
    cout << "y-Position (1-" << PlayFieldY << "): ";
    cin >> y;
    cout << endl;
    }while(x < 1 || x > PlayFieldX || y < 1 || y > PlayFieldY );

    if (sSpielfeld[x-1][y-1].enemy == true)
    {
        cout <<"Auf diesen Feld steht ein " << sSpielfeld[x-1][y-1].cName <<".\n" << endl;
    }
    else
    {
        cout << "Spielfeld nicht besetzt\n" << endl;
    }
}

void deleteField()
{
    for (int y = 0; y < PlayFieldY; y++)
    {
     for (int x = 0; x < PlayFieldX; x++)
     {
      sSpielfeld[x][y].status = false;
     }
    }
    cout << "Spielfeld wurde geloescht!" << endl << endl;
}


int main()
{
    int iAuswahl;

    while(1) //main-while
    {
        //Men
        do
        {
            cout << "1 - Spielfeld anzeigen" << endl;
            cout << "2 - Feld besetzen" << endl;
            cout << "3 - Felddaten anzeigen" << endl;
            cout << "4 - Spielfeld loeschen" << endl;
            cout << "5 - Programm beenden" << endl;
            cout << "Auswahl: ";
            cin >> iAuswahl;
            cout << endl;
        } while(iAuswahl < 1 || iAuswahl > 5);

        switch (iAuswahl)
        {
                case (1):
                    {
                    showPlayfield();
                    }break;
                case (2):
                    {
                    setField();
                    }break;
                case (3):
                    {
                    showField();
                    }break;
                case (4):
                    {
                    deleteField();
                    }break;
                case (5):
                    {
                    return 0;
                    }break;
        }


    }//main-while
}
